/*
 * Delay.c
 *
 *  Created on: Jan 23, 2019
 *      Author: jake
 */

#include "Delay.h"

/*
 *  This function will delay the computations by delayTime cycles
 */
void delay_init(void)
{
    Timer32_initModule(TIMER32_0_BASE, TIMER32_PRESCALER_1, TIMER32_32BIT, TIMER32_PERIODIC_MODE);

    Timer32_disableInterrupt(TIMER32_0_BASE);
}

void delay(uint32_t duration_us)
{
    Timer32_haltTimer (TIMER32_0_BASE);
    Timer32_setCount  (TIMER32_0_BASE, 24 * duration_us);
    Timer32_startTimer(TIMER32_0_BASE, true);

    while (Timer32_getValue(TIMER32_0_BASE) > 0);
}


